(: (Q1)
 : Convert the sample document from "partlist" format to "parttree" 
 : format (see DTD section for definitions). In the result document, 
 : part containment is represented by containment of one <part> element 
 : inside another. Each part that is not part of any other part should 
 : appear as a separate top-level element in the output document. 
 :)

declare function local:one_level($p as element()) as element()
{
    <part partid="{ $p/@partid }"
          name="{ $p/@name }" >
        {
            for $s in doc("data/parts-data.xml")//part
            where $s/@partof = $p/@partid
            return local:one_level($s)
        }
    </part>
};

<parttree>
  {
    for $p in doc("data/parts-data.xml")//part[empty(@partof)]
    return local:one_level($p)
  }
</parttree>
