(: (Q12)
 : List the item number and description of the item(s) that
 : received the largest number of bids, and the number of
 : bids it (or they) received.
 :)

declare function local:bid_summary()
  as element()*
{
    for $i in distinct-values(doc("data/R-bids.xml")//itemno)
    let $b := doc("data/R-bids.xml")//bid_tuple[itemno = $i]
    return
        <bid_count>
            <itemno>{ $i }</itemno>
            <nbids>{ count($b) }</nbids>
        </bid_count>
};

declare function local:dec-max($i as item()*)
 as xs:decimal
{
    max( for $j in $i return xs:decimal($j) )
};

<result>
 {
    let $bid_counts := local:bid_summary(),
        $maxbids := local:dec-max($bid_counts/nbids),
        $maxitemnos := $bid_counts[nbids = $maxbids]
    for $item in doc("data/R-items.xml")//item_tuple,
        $bc in $bid_counts
    where $bc/nbids =  $maxbids and $item/itemno = $bc/itemno
    return
        <popular_item>
            { $item/itemno }
            { $item/description }
            <bid_count>{ $bc/nbids/text() }</bid_count>
        </popular_item>
 }
</result>
