xquery version "1.0";
(: (Q2)
 : Find news items where the Foobar Corporation and one or more 
 : of its partners are mentioned in the same paragraph and/or title. 
 : List each news item by its title and date. 
 :)


declare function local:partners($company as xs:string) as element()*
{
    let $c := doc("data/text-company.xml")//company[name = $company]
    return $c//partner
};

let $foobar_partners := local:partners("Foobar Corporation")

for $item in doc("data/text-news.xml")//news_item
where
  some $t in $item//title satisfies
    (contains($t/text(), "Foobar Corporation")
    and (some $partner in $foobar_partners satisfies
      contains($t/text(), $partner/text())))
  or (some $par in $item//par satisfies
   (contains(string($par), "Foobar Corporation")
     and (some $partner in $foobar_partners satisfies
        contains(string($par), $partner/text())))) 
return
    <news_item>
        { $item/title }
        { $item/date }
    </news_item>
