(: (Q4)
 : Return purchase orders with an erroneous postal code 
 : or zip code (depending on whether it is a UK Address or a US Address).
 :) 


import schema namespace ipo="http://www.example.com/IPO" at "data/ipo.xsd";
import schema namespace pst="http://www.example.com/postals" at "data/postals.xsd";
import schema namespace zips="http://www.example.com/zips" at "data/zips.xsd";

import module namespace zok="http://www.example.com/xq/zips" at "usecases/strong/strongq2.xquery";
import module namespace pok="http://www.example.com/xq/postals" at "usecases/strong/strongq3.xquery";

declare function local:address-ok($a as element(*, ipo:Address))
 as xs:boolean
{
  typeswitch ($a)
      case $zip as element(*, ipo:USAddress)
           return zok:zip-ok($zip)
      case $postal as element(*, ipo:UKAddress )
           return pok:postal-ok($postal)
      default return false()
};

let $shipTo := doc("data/ipo.xml")/element(ipo:purchaseOrder)/ipo:shipTo
let $billTo := doc("data/ipo.xml")/element(ipo:purchaseOrder)/ipo:billTo
return local:address-ok($shipTo) and local:address-ok($billTo)