(:
    a 4-way join with an additional nested aggregation query, where loop-invariants pay off substantially
    - even for the small data set at hand.
:)

for $seller in doc("data/R-users.xml")//user_tuple,
        $buyer in  doc("data/R-users.xml")//user_tuple,
        $item in  doc("data/R-items.xml")//item_tuple,
        $highbid in  doc("data/R-bids.xml")//bid_tuple
    where $seller/name = "Tom Jones"
      and $seller/userid  = $item/offered_by
      and contains($item/description , "Bicycle")
      and $item/itemno  = $highbid/itemno
      and $highbid/userid  = $buyer/userid
      and $highbid/bid = max(
                             for $x in doc("data/R-bids.xml")//bid_tuple
                                  [itemno = $item/itemno]/bid 
                             return xs:decimal($x)
                         )
return $item
